Index: tmp/org.txm.queryindex.rcp/src/org/txm/rcp/editors/queryindex/QueryIndexEditor.java
===================================================================
--- tmp/org.txm.queryindex.rcp/src/org/txm/rcp/editors/queryindex/QueryIndexEditor.java	(revision 0)
+++ tmp/org.txm.queryindex.rcp/src/org/txm/rcp/editors/queryindex/QueryIndexEditor.java	(revision 673)
@@ -0,0 +1,1115 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.rcp.editors.queryindex;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.jface.action.MenuManager;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.StructuredSelection;
+import org.eclipse.jface.viewers.TableViewer;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.custom.ScrolledComposite;
+import org.eclipse.swt.events.ControlAdapter;
+import org.eclipse.swt.events.ControlEvent;
+import org.eclipse.swt.events.KeyEvent;
+import org.eclipse.swt.events.KeyListener;
+import org.eclipse.swt.events.MouseAdapter;
+import org.eclipse.swt.events.MouseEvent;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.graphics.Font;
+import org.eclipse.swt.graphics.FontData;
+import org.eclipse.swt.graphics.Image;
+import org.eclipse.swt.graphics.Point;
+import org.eclipse.swt.graphics.Rectangle;
+import org.eclipse.swt.layout.FormAttachment;
+import org.eclipse.swt.layout.FormData;
+import org.eclipse.swt.layout.FormLayout;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Display;
+import org.eclipse.swt.widgets.FileDialog;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Menu;
+import org.eclipse.swt.widgets.Spinner;
+import org.eclipse.swt.widgets.TableColumn;
+import org.eclipse.ui.IEditorInput;
+import org.eclipse.ui.IEditorSite;
+import org.eclipse.ui.PartInitException;
+import org.eclipse.ui.part.EditorPart;
+import org.txm.core.results.TXMResult;
+import org.txm.functions.queryindex.QueryIndex;
+import org.txm.functions.queryindex.QueryIndexLine;
+import org.txm.index.core.functions.LineComparator.SortMode;
+import org.txm.index.rcp.messages.IndexUIMessages;
+import org.txm.rcp.JobsTimer;
+import org.txm.rcp.RCPMessages;
+import org.txm.rcp.StatusLine;
+import org.txm.rcp.editors.TXMEditor;
+import org.txm.rcp.editors.TableKeyListener;
+import org.txm.rcp.swt.dialog.LastOpened;
+import org.txm.rcp.swt.widget.NamedAssistedQueryWidget;
+import org.txm.rcp.swt.widget.NavigationWidget;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.rcp.views.QueriesView;
+import org.txm.rcp.views.corpora.CorporaView;
+import org.txm.rcp.editors.input.QueryIndexEditorInput;
+import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.Partition;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.statsengine.r.rcp.views.RVariablesView;
+import org.txm.utils.logger.Log;
+import org.txm.functions.queryindex.*;
+
+/**
+ * display the query index parameters and result.
+ * 
+ * @author mdecorde
+ */
+public class QueryIndexEditor extends TXMEditor<QueryIndex> {
+
+	/** The Constant ID. */
+	public static final String ID = "org.txm.rcp.editors.queryindex.QueryIndexEditor"; //$NON-NLS-1$
+
+	/** The corpus. */
+	protected Corpus corpus;
+	protected Partition partition; // can be null
+
+	/** The index. */
+	protected QueryIndex queryindex;
+	boolean stored = false; // start storing at first line added
+	// protected boolean saveQueryIndex = true;
+
+	// params
+	/** The query label. */
+	protected Label queryLabel;
+
+	/** The query widget. */
+	protected NamedAssistedQueryWidget queryWidget;
+
+	/** The N ligne p page spinner. */
+	protected Spinner NLignePPageSpinner;
+	// infos
+	/** The navigation area. */
+	protected NavigationWidget navigationArea;
+
+	/** The l fmin info. */
+	protected Label lFminInfo;
+
+	/** The l fmax info. */
+	protected Label lFmaxInfo;
+
+	/** The l v info. */
+	protected Label lVInfo;
+
+	/** The l t info. */
+	protected Label lTInfo;
+	// result
+	/** The line table viewer. */
+	protected TableViewer viewer;
+
+	/** The n column. */
+	protected TableColumn nColumn;
+
+	/** The unit column. */
+	protected TableColumn unitColumn;
+
+	/** The freq column. */
+	protected TableColumn freqColumn;
+
+	/** The separator column. */
+	protected TableColumn separatorColumn;
+
+	/** The top line. */
+	protected int topLine;
+
+	/** The bottom line. */
+	protected int bottomLine;
+
+	/** The nblinesperpage. */
+	protected int nblinesperpage;
+
+	/** The nblinesmax. */
+	protected int nblinesmax;
+
+	/** The scroll composite. */
+	private ScrolledComposite scrollComposite;
+
+	/** The head composite. */
+	private Composite headComposite;
+
+	/** The title. */
+	String title;
+
+	/**
+	 * Instantiates a new index editor.
+	 */
+	public QueryIndexEditor() {
+		super();
+	}
+
+	/**
+	 * Do save.
+	 * 
+	 * @param arg0
+	 *            the arg0
+	 * @see org.eclipse.ui.part.EditorPart#doSave(org.eclipse.core.runtime.IProgressMonitor)
+	 */
+	@Override
+	public void doSave(IProgressMonitor arg0) {
+		// TODO Auto-generated method stub
+	}
+
+	/**
+	 * Do save as.
+	 * 
+	 * @see org.eclipse.lyon gournd zeroui.part.EditorPart#doSaveAs()
+	 */
+	@Override
+	public void doSaveAs() {
+		// TODO Auto-generated method stub
+	}
+
+	/**
+	 * Inits the.
+	 * 
+	 * @param site
+	 *            the site
+	 * @param input
+	 *            the input
+	 * @throws PartInitException
+	 *             the part init exception
+	 * @see org.eclipse.ui.part.EditorPart#init(org.eclipse.ui.IEditorSite,
+	 *      org.eclipse.ui.IEditorInput)
+	 */
+	@Override
+	public void init(IEditorSite site, IEditorInput input)
+			throws PartInitException {
+		setSite(site);
+		setInput(input);
+
+		this.corpus = ((QueryIndexEditorInput) input).getCorpus();
+		this.partition = ((QueryIndexEditorInput) input).getPartition();
+		this.queryindex = ((QueryIndexEditorInput) input).getQueryIndex();
+	}
+
+	/**
+	 * Checks if is dirty.
+	 * 
+	 * @return true, if is dirty
+	 * @see org.eclipse.ui.part.EditorPart#isDirty()
+	 */
+	@Override
+	public boolean isDirty() {
+		return false;
+	}
+
+	/**
+	 * Checks if is save as allowed.
+	 * 
+	 * @return true, if is save as allowed
+	 * @see org.eclipse.ui.part.EditorPart#isSaveAsAllowed()
+	 */
+	@Override
+	public boolean isSaveAsAllowed() {
+		return false;
+	}
+
+	private QueryIndex createQueryIndex() {
+		if (queryindex == null) {
+			if (partition != null) {
+				queryindex = new QueryIndex(partition);
+				title = Messages.QueryIndexEditor_0 + partition.getName();
+			} else {
+				queryindex = new QueryIndex(corpus);
+				title = Messages.QueryIndexEditor_0 + corpus;
+			}
+		}
+		return queryindex;
+	}
+
+	/**
+	 * Compute index.
+	 */
+	public void compute() {
+
+		createQueryIndex();
+
+		StatusLine.setMessage(IndexUIMessages.IndexEditor_33);
+		final Query query; // if the query is empty then we put "[]" instead
+		if (!queryWidget.getQueryString().equals("\"\"")) {//$NON-NLS-1$
+			query = new Query(queryWidget.getQueryString());
+		} else {
+			System.err.println(IndexUIMessages.IndexEditor_0);
+			return;
+		}
+
+		final String name;
+		if (queryWidget.getQueryName().length() == 0) {
+			name = query.toString();
+		} else {
+			name = queryWidget.getQueryName();
+		}
+
+		try {
+			JobHandler jobhandler = new JobHandler(title,
+					queryWidget.getParent()) {
+				@Override
+				protected IStatus run(IProgressMonitor monitor) {
+					this.runInit(monitor);
+					JobsTimer.start();
+					final QueryIndexLine line;
+					try {
+						try {
+							if (queryindex.hasLine(name)) {
+								System.out.println(Messages.QueryIndexEditor_1 + name);
+								queryindex.removeLine(name);
+							}
+							line = queryindex.addLine(name, query);
+						} catch (CqiClientException e2) {
+							System.out
+									.println(Messages.QueryIndexEditor_2
+											+ query);
+							Log.printStackTrace(e2);
+							return Status.CANCEL_STATUS;
+						}
+
+						if (line == null) {
+							System.out
+									.println(Messages.QueryIndexEditor_2
+											+ query);
+							return Status.CANCEL_STATUS;
+						}
+
+						if (monitor.isCanceled())
+							return Status.CANCEL_STATUS;
+
+						queryindex.sortLines(SortMode.FREQUNIT, true);
+
+						if (monitor.isCanceled())
+							return Status.CANCEL_STATUS;
+
+						this.acquireSemaphore();
+						this.releaseSemaphore();
+
+						final String message = Messages.QueryIndexEditor_3;
+
+						if (monitor.isCanceled())
+							return Status.CANCEL_STATUS;
+
+						monitor.worked(95);
+						// refresh ui
+						syncExec(new Runnable() {
+							@Override
+							public void run() {
+
+								System.out.println(message);
+								StatusLine.setMessage(message);
+
+								CorporaView.refresh();
+								CorporaView.expand(queryindex.getParent());
+								QueriesView.refresh();
+								RVariablesView.refresh();
+
+								setPartName(title);
+
+								queryWidget.memorize();
+								nblinesperpage = NLignePPageSpinner
+										.getSelection();
+
+								fillDisplayArea(0,
+										NLignePPageSpinner.getSelection());
+
+								if (line != null) {
+									queryWidget.setText(""); //$NON-NLS-1$
+									queryWidget.setName(""); //$NON-NLS-1$
+									queryWidget.focus();
+								}
+							}
+						});
+					} catch (Exception e) {
+						System.out.println(e.getLocalizedMessage());
+						try {
+							System.out.println(RCPMessages.LastCQPError
+									+ CQPEngine.getCqiClient().getLastCQPError());
+						} catch (Exception e1) {
+							System.out.println(IndexUIMessages.IndexEditor_10
+									+ e1);
+							Log.printStackTrace(e1);
+						}
+						Log.severe("Error while computing QueryIndex: "+e.getLocalizedMessage());
+					} catch (ThreadDeath td) {
+						return Status.CANCEL_STATUS;
+					} finally {
+						monitor.done();
+						JobsTimer.stopAndPrint();
+					}
+					return Status.OK_STATUS;
+				}
+			};
+			jobhandler.startJob();
+
+		} catch (Exception e1) {
+			Log.printStackTrace(e1);
+		}
+	}
+
+	/**
+	 * Creates the part control.
+	 * 
+	 * @param parent
+	 *            the parent
+	 * @see org.eclipse.ui.part.WorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
+	 */
+	@Override
+	public void _createPartControl(final Composite parent) {
+		FormLayout parentLayout = new FormLayout();
+		parent.setLayout(parentLayout);
+
+		// create scrollable area
+		scrollComposite = new ScrolledComposite(parent, SWT.H_SCROLL | SWT.NONE);
+		FormData headLayoutData = new FormData();
+		headLayoutData.top = new FormAttachment(0, 0);
+		headLayoutData.left = new FormAttachment(0);
+		headLayoutData.right = new FormAttachment(100);
+		scrollComposite.setLayoutData(headLayoutData);
+		scrollComposite.setLayout(new FormLayout());
+
+		headComposite = new Composite(scrollComposite, SWT.NONE);
+		headLayoutData = new FormData();
+		headLayoutData.top = new FormAttachment(0);
+		headLayoutData.bottom = new FormAttachment(100);
+		headLayoutData.left = new FormAttachment(0);
+		headLayoutData.right = new FormAttachment(100);
+		headComposite.setLayoutData(headLayoutData);
+		headComposite.setLayout(new FormLayout());
+
+		scrollComposite.setContent(headComposite);
+		scrollComposite.setExpandVertical(true);
+		scrollComposite.setExpandHorizontal(true);
+		scrollComposite.addControlListener(new ControlAdapter() {
+			@Override
+			public void controlResized(ControlEvent e) {
+				Rectangle r = scrollComposite.getClientArea();
+				scrollComposite.setMinSize(headComposite.computeSize(
+						SWT.DEFAULT, SWT.DEFAULT));
+			}
+		});
+
+		final Composite paramArea = new Composite(headComposite, SWT.NONE);
+		FormData paramLayoutData = new FormData();
+		paramLayoutData.top = new FormAttachment(0);
+		paramLayoutData.left = new FormAttachment(0);
+		paramLayoutData.right = new FormAttachment(100);
+		paramArea.setLayoutData(paramLayoutData);
+
+		// info&navigation panel
+		// final Composite infosArea = new Composite(headComposite, SWT.NONE);
+		// FormData infosLayoutData = new FormData();
+		// infosLayoutData.top = new FormAttachment(paramArea, 0);
+		// infosLayoutData.left = new FormAttachment(0);
+		// infosLayoutData.right = new FormAttachment(100);
+		// infosArea.setLayoutData(infosLayoutData);
+
+		Composite resultArea = new Composite(parent, SWT.NONE);
+		FormData resultLayoutData = new FormData();
+		resultLayoutData.top = new FormAttachment(scrollComposite, 0);
+		resultLayoutData.left = new FormAttachment(0);
+		resultLayoutData.right = new FormAttachment(100);
+		resultLayoutData.bottom = new FormAttachment(100);
+		resultArea.setLayoutData(resultLayoutData);
+
+		// compose paramArea
+		FormLayout paramLayout = new FormLayout();
+		paramArea.setLayout(paramLayout);
+
+		// on créé une Query, ici le pivot de la concordance est "[]"
+		// Query Area: query itself + view properties
+		Composite queryArea = new Composite(paramArea, SWT.NONE);
+
+		FormData queryLayoutData = new FormData();
+		queryLayoutData.top = new FormAttachment(0);
+		queryLayoutData.left = new FormAttachment(0);
+		queryLayoutData.right = new FormAttachment(100);
+		queryArea.setLayoutData(queryLayoutData);
+
+		queryArea.setLayout(new GridLayout(4, false));
+
+		// | Query: [ (v)] [Search] |
+		// Query:
+		// queryLabel = new Label(queryArea, SWT.NONE);
+		// queryLabel.setText(RCPMessages.IndexEditor_3);
+		// queryLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
+		// true));
+
+		// [ (v)]
+		queryWidget = new NamedAssistedQueryWidget(queryArea, SWT.DROP_DOWN,
+				this.corpus);
+		GridData layoutData = new GridData(GridData.VERTICAL_ALIGN_CENTER);
+		layoutData.horizontalAlignment = GridData.FILL;
+		layoutData.grabExcessHorizontalSpace = true;
+		queryWidget.setLayoutData(layoutData);
+		queryWidget.addKeyListener(new KeyListener() {
+			@Override
+			public void keyPressed(KeyEvent e) {
+				// System.out.println("key pressed : "+e.keyCode);
+				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
+					compute();
+				}
+			}
+
+			@Override
+			public void keyReleased(KeyEvent e) {
+			}
+		});
+
+		Button loadFromFile = new Button(queryArea, SWT.BOLD);
+		loadFromFile.setEnabled(true);
+		loadFromFile.setText(Messages.QueryIndexEditor_4);
+		loadFromFile
+				.setLayoutData(new GridData(GridData.VERTICAL_ALIGN_CENTER));
+		loadFromFile.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				File propFile = null;
+				if (LastOpened.getFile(ID) != null)
+					propFile = new File(LastOpened.getFolder(ID));
+
+				FileDialog dialog = new FileDialog(parent.getShell(), SWT.OPEN);
+				String[] exts = { "*.properties" }; //$NON-NLS
+				dialog.setFilterExtensions(exts);
+				if (propFile != null) {
+					dialog.setFilterPath(propFile.getParent());
+					dialog.setFileName(propFile.getName());
+				}
+				String path = dialog.open();
+				if (path != null) {
+					propFile = new File(path);
+					// compute();
+					// System.out.println("TODO: load from file "+propFile);
+					createQueryIndex();
+					try {
+						queryindex.addLinesFromFile(propFile);
+						queryindex.sortLines(SortMode.FREQUNIT, true);
+
+						stored = true;
+
+						fillDisplayArea(0, NLignePPageSpinner.getSelection());
+
+						CorporaView.refresh();
+						CorporaView.expand(queryindex.getParent());
+						QueriesView.refresh();
+						RVariablesView.refresh();
+
+						setPartName(title);
+
+						queryWidget.focus();
+					} catch (CqiClientException e1) {
+						// TODO Auto-generated catch block
+						Log.printStackTrace(e1);
+					} catch (IOException e1) {
+						// TODO Auto-generated catch block
+						System.out
+								.println(Messages.QueryIndexEditor_6 + propFile);
+						Log.printStackTrace(e1);
+					}
+				}
+			}
+
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+			}
+		});
+
+		Button go = new Button(queryArea, SWT.BOLD);
+		go.setText(IndexUIMessages.IndexEditor_4);
+
+		Font f = go.getFont();
+		FontData defaultFont = f.getFontData()[0];
+		defaultFont.setStyle(SWT.BOLD);
+		Font newf = new Font(go.getDisplay(), defaultFont);
+		go.setFont(newf);
+
+		layoutData = new GridData(GridData.VERTICAL_ALIGN_CENTER);
+		layoutData.horizontalAlignment = GridData.FILL;
+		layoutData.grabExcessHorizontalSpace = false;
+		go.setLayoutData(layoutData);
+
+		go.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				compute();
+			}
+
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+			}
+		});
+
+		// Filters
+		Composite filtercontrols = new Composite(paramArea, SWT.NONE);
+		FormData filtersLayoutData = new FormData();
+		filtersLayoutData.top = new FormAttachment(queryArea, 0);
+		filtersLayoutData.bottom = new FormAttachment(100);
+		filtersLayoutData.left = new FormAttachment(0);
+		filtersLayoutData.right = new FormAttachment(100);
+		filtercontrols.setLayoutData(filtersLayoutData);
+
+		GridLayout gridLayout = new GridLayout();
+		gridLayout.numColumns = 9;
+		gridLayout.makeColumnsEqualWidth = false;
+		filtercontrols.setLayout(gridLayout);
+
+		Label lNLigneppage = new Label(filtercontrols, SWT.NONE);
+		lNLigneppage.setText(IndexUIMessages.IndexEditor_8);
+		lNLigneppage.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
+				false));
+
+		NLignePPageSpinner = new Spinner(filtercontrols, SWT.BORDER);
+		NLignePPageSpinner.setMinimum(0);
+		NLignePPageSpinner.setMaximum(99999);
+		NLignePPageSpinner.setSelection(100);
+		NLignePPageSpinner.setIncrement(1);
+		NLignePPageSpinner.setPageIncrement(100);
+		NLignePPageSpinner.setLayoutData(new GridData(
+				GridData.VERTICAL_ALIGN_END));
+		NLignePPageSpinner.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+			}
+
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				fillDisplayArea(0, NLignePPageSpinner.getSelection());
+				viewer.getTable().select(0);
+				viewer.getTable().showSelection();
+			}
+		});
+
+		// compose infosArea
+		// infosArea.setLayout(new GridLayout(6, false));
+
+		navigationArea = new NavigationWidget(filtercontrols, SWT.NONE);
+		navigationArea.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true,
+				false));
+
+		navigationArea.addFirstListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				fillDisplayArea(0, NLignePPageSpinner.getSelection());
+				viewer.getTable().select(0);
+				viewer.getTable().showSelection();
+			}
+		});
+		navigationArea.addLastListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				int top = (queryindex.getV() / NLignePPageSpinner
+						.getSelection()) * NLignePPageSpinner.getSelection();
+				int bottom = top + NLignePPageSpinner.getSelection();
+				fillDisplayArea(top, bottom);
+				viewer.getTable().select(0);
+				viewer.getTable().showSelection();
+			}
+		});
+		navigationArea.addNextListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				int top = topLine + NLignePPageSpinner.getSelection();
+				int bottom = top + NLignePPageSpinner.getSelection();
+				fillDisplayArea(top, bottom);
+				viewer.getTable().select(0);
+				viewer.getTable().showSelection();
+			}
+		});
+		navigationArea.addPreviousListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				int top = topLine - NLignePPageSpinner.getSelection();
+				if (top < 0)
+					top = 0;
+				int bottom = top + NLignePPageSpinner.getSelection();
+				fillDisplayArea(top, bottom);
+				viewer.getTable().select(0);
+				viewer.getTable().showSelection();
+			}
+		});
+
+		// Labels
+		lTInfo = new Label(filtercontrols, SWT.NONE);
+		lTInfo.setText(""); //$NON-NLS-1$
+		lTInfo.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false));
+
+		lVInfo = new Label(filtercontrols, SWT.NONE);
+		lVInfo.setText(""); //$NON-NLS-1$
+		lVInfo.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false));
+
+		lFminInfo = new Label(filtercontrols, SWT.NONE);
+		lFminInfo.setText(""); //$NON-NLS-1$
+		lFminInfo
+				.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false));
+
+		lFmaxInfo = new Label(filtercontrols, SWT.NONE);
+		lFmaxInfo.setText(""); //$NON-NLS-1$
+		lFmaxInfo
+				.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false));
+
+		// results
+		FormLayout resultLayout = new FormLayout();
+		resultArea.setLayout(resultLayout);
+
+		viewer = new TableViewer(resultArea, SWT.MULTI | SWT.FULL_SELECTION
+				| SWT.BORDER);
+		viewer.getTable().setLinesVisible(true);
+		viewer.getTable().setHeaderVisible(true);
+		viewer.getTable().addKeyListener(new TableKeyListener(viewer));
+
+		if (corpus != null && corpus.getFont() != null
+				&& corpus.getFont().length() > 0) {
+			Font old = viewer.getTable().getFont();
+			FontData fD = old.getFontData()[0];
+			Font font = new Font(Display.getCurrent(), corpus.getFont(),
+					fD.getHeight(), fD.getStyle());
+			viewer.getTable().setFont(font);
+		}
+
+		FormData tableLayoutData = new FormData();
+		tableLayoutData.top = new FormAttachment(0);
+		tableLayoutData.bottom = new FormAttachment(100);
+		tableLayoutData.left = new FormAttachment(0);
+		tableLayoutData.right = new FormAttachment(100);
+		viewer.getTable().setLayoutData(tableLayoutData);
+
+		viewer.setLabelProvider(new LineLabelProvider());
+		viewer.setContentProvider(new LineContentProvider());
+		viewer.setInput(new ArrayList<Property>());
+
+		viewer.getTable().addMouseListener(new MouseAdapter() {
+			@Override
+			public void mouseDoubleClick(MouseEvent e) {
+				Point mouseposition = new Point(e.x
+						+ viewer.getTable().getHorizontalBar().getSelection(),
+						e.y);
+				int col = getPointedColumn(mouseposition);
+				if (col == 1) {
+					// IndexToConcordance.link(self,
+					// (IStructuredSelection) viewer
+					// .getSelection());
+					System.out.println(Messages.QueryIndexEditor_7);
+				} else if (col == 2) {
+					System.out.println(Messages.QueryIndexEditor_8);
+				}
+			}
+		});
+
+		viewer.getTable().addKeyListener(new KeyListener() {
+			@Override
+			public void keyReleased(KeyEvent e) {
+			}
+
+			@Override
+			public void keyPressed(KeyEvent e) {
+				if (e.keyCode == SWT.DEL) {
+					System.out.println(Messages.QueryIndexEditor_9);
+					ISelection sel = viewer.getSelection();
+					if (sel instanceof StructuredSelection) {
+						List<?> lines = ((StructuredSelection) sel).toList();
+						for (Object obj : lines) {
+							if (obj instanceof QueryIndexLine) {
+								QueryIndexLine line = (QueryIndexLine) obj;
+								queryindex.removeLine(line.getName());
+							}
+						}
+						fillDisplayArea(topLine, bottomLine);
+					}
+				}
+			}
+		});
+
+		nColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
+		nColumn.setText(" "); //$NON-NLS-1$
+		nColumn.pack();
+
+		unitColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
+		unitColumn.setText(RCPMessages.ReferencerEditor_9);
+		unitColumn.setToolTipText(RCPMessages.ReferencerEditor_9);
+		unitColumn.setWidth(200);
+		unitColumn.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				StatusLine.setMessage(IndexUIMessages.IndexEditor_36);
+				if (viewer.getTable().getSortColumn() != unitColumn) {
+					viewer.getTable().setSortColumn(unitColumn);
+					viewer.getTable().setSortDirection(SWT.UP);
+					queryindex.sortLines(SortMode.UNITFREQ, false);
+				} else {
+					if (viewer.getTable().getSortDirection() == SWT.UP) {
+						viewer.getTable().setSortDirection(SWT.DOWN);
+						queryindex.sortLines(SortMode.UNITFREQ, true);
+					} else {
+						viewer.getTable().setSortDirection(SWT.UP);
+						queryindex.sortLines(SortMode.UNITFREQ, false);
+					}
+				}
+
+				StatusLine.setMessage(IndexUIMessages.IndexEditor_37);
+				fillDisplayArea(topLine, bottomLine);
+			}
+
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+			}
+		});
+
+		freqColumn = new TableColumn(viewer.getTable(), SWT.RIGHT);
+		try {
+			if (partition != null)
+				freqColumn.setText(RCPMessages.FrequencyListEditorInput_4
+						+ " T=" + partition.getTotalSize()); //$NON-NLS-1$
+			else
+				freqColumn.setText(RCPMessages.FrequencyListEditorInput_4
+						+ " T=" + corpus.getSize()); //$NON-NLS-1$
+		} catch (CqiClientException e2) {
+			Log.printStackTrace(e2);
+			return;
+		}
+		freqColumn.setToolTipText(RCPMessages.FrequencyListEditorInput_4);
+		freqColumn.setWidth(100);
+		freqColumn.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				if (viewer.getTable().getSortColumn() != freqColumn) {
+					viewer.getTable().setSortColumn(freqColumn);
+					viewer.getTable().setSortDirection(SWT.UP);
+					queryindex.sortLines(SortMode.FREQUNIT, false);
+				} else {
+					if (viewer.getTable().getSortDirection() == SWT.UP) {
+						viewer.getTable().setSortDirection(SWT.DOWN);
+						queryindex.sortLines(SortMode.FREQUNIT, true);
+					} else {
+						viewer.getTable().setSortDirection(SWT.UP);
+						queryindex.sortLines(SortMode.FREQUNIT, false);
+					}
+				}
+				StatusLine.setMessage(IndexUIMessages.IndexEditor_37);
+				fillDisplayArea(topLine, bottomLine);
+			}
+
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+			}
+		});
+
+		// rmv/creates parts columns if needed
+		if (this.partition != null) {
+			List<String> partnames = this.partition.getPartNames();
+			if (partnames.size() > 1)
+				if (viewer.getTable().getColumnCount() < partnames.size() + 3) {
+					for (int i = 0; i < partnames.size(); i++) {
+						final TableColumn partColumn = new TableColumn(
+								viewer.getTable(), SWT.RIGHT);
+						try {
+							partColumn
+									.setText(partnames.get(i)
+											+ " t=" + partition.getParts().get(i).getSize()); //$NON-NLS-1$
+						} catch (CqiClientException e1) {
+							Log.printStackTrace(e1);
+							return;
+						}
+						partColumn.setToolTipText(partnames.get(i));
+						partColumn.setWidth(100);
+						partColumn
+								.addSelectionListener(new SelectionListener() {
+									@Override
+									public void widgetSelected(SelectionEvent e) {
+										if (viewer.getTable().getSortColumn() != partColumn) {
+											viewer.getTable().setSortColumn(
+													partColumn);
+											viewer.getTable().setSortDirection(
+													SWT.UP);
+											queryindex.sortLines(
+													SortMode.FREQUNIT, false);
+										} else {
+											if (viewer.getTable()
+													.getSortDirection() == SWT.UP) {
+												viewer.getTable()
+														.setSortDirection(
+																SWT.DOWN);
+												queryindex
+														.sortLines(
+																SortMode.FREQUNIT,
+																true);
+											} else {
+												viewer.getTable()
+														.setSortDirection(
+																SWT.UP);
+												queryindex.sortLines(
+														SortMode.FREQUNIT,
+														false);
+											}
+										}
+										fillDisplayArea(topLine, bottomLine);
+									}
+
+									@Override
+									public void widgetDefaultSelected(
+											SelectionEvent e) {
+									}
+								});
+					}
+				}
+		}
+		separatorColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
+		separatorColumn.setText(""); //$NON-NLS-1$
+		separatorColumn.pack();
+
+		initializeFields();
+		createContextMenu(viewer);
+		viewer.getTable().pack();
+	}
+
+	/**
+	 * Gets the pointed column.
+	 * 
+	 * @param mouseposition
+	 *            the mouseposition
+	 * @return the pointed column
+	 */
+	public int getPointedColumn(Point mouseposition) {
+		int x = mouseposition.x; // + lineTableViewer.getTable().get;
+		int sumWidthColumn = this.nColumn.getWidth();
+		if (x < sumWidthColumn)
+			return 0;
+
+		sumWidthColumn += this.unitColumn.getWidth();
+		if (x < sumWidthColumn)
+			return 1;
+
+		sumWidthColumn += this.freqColumn.getWidth();
+		if (x < sumWidthColumn)
+			return 2;
+
+		return 2;
+	}
+
+	/**
+	 * Creates the context menu.
+	 * 
+	 * @param tableViewer
+	 *            the table viewer
+	 */
+	private void createContextMenu(TableViewer tableViewer) {
+		MenuManager menuManager = new MenuManager();
+		Menu menu = menuManager.createContextMenu(tableViewer.getTable());
+
+		// Set the MenuManager
+		tableViewer.getTable().setMenu(menu);
+		getSite().registerContextMenu(menuManager, tableViewer);
+		// Make the selection available
+		getSite().setSelectionProvider(tableViewer);
+	}
+
+	/**
+	 * Initialize fields.
+	 */
+	public void initializeFields() {
+		if (this.queryindex != null) {
+
+			if (queryindex.getPartition() != null)
+				setPartName(queryindex.getPartition().getName()
+						+ ": " + queryindex.getName()); //$NON-NLS-1$
+			else
+				setPartName(queryindex.getCorpus().getName()
+						+ ": " + queryindex.getName()); //$NON-NLS-1$
+			queryWidget.setFocus();
+
+			queryindex.sortLines(SortMode.FREQUNIT, true);
+
+			fillDisplayArea(0, NLignePPageSpinner.getSelection());
+		} else if (this.corpus != null) {
+			// no query
+			queryWidget.setText(""); //$NON-NLS-1$
+
+			if (partition != null) {
+				setPartName(partition.getName());
+			} else {
+				setPartName(corpus.getName());
+			}
+			queryWidget.setFocus();
+		} else {
+			System.err.println(IndexUIMessages.IndexEditor_22);
+		}
+	}
+
+	/**
+	 * Fill display area.
+	 * 
+	 * @param from
+	 *            the from
+	 * @param to
+	 *            the to
+	 */
+	public void fillDisplayArea(int from, int to) {
+		// System.out.println("call fill from "+from+" to "+to);
+		from = Math.max(from, 0);
+		to = Math.min(to, queryindex.getV());
+		ArrayList<QueryIndexLine> lines = null;
+		if (queryindex.getV() > 0) {
+			lines = queryindex.getLines(from, to);
+		} else
+			lines = new ArrayList<QueryIndexLine>();
+
+		navigationArea.setInfoLineText("" + (from + 1), //$NON-NLS-1$
+				"-" + (to) + " / " + queryindex.getV()); //$NON-NLS-1$ //$NON-NLS-2$
+		navigationArea.setPreviousEnabled(from > 0);
+		navigationArea.setFirstEnabled(from > 0);
+		navigationArea.setNextEnabled(to < queryindex.getV() - 1);
+		navigationArea.setLastEnabled(to < queryindex.getV() - 1);
+
+		lFminInfo.setText(IndexUIMessages.IndexEditor_25 + queryindex.getFmin());
+		lFmaxInfo.setText(IndexUIMessages.IndexEditor_26 + queryindex.getFmax());
+		lTInfo.setText(IndexUIMessages.IndexEditor_27 + queryindex.getT());
+		lVInfo.setText(IndexUIMessages.IndexEditor_28 + queryindex.getV());
+
+		lVInfo.getParent().layout();
+
+		unitColumn.setText(Messages.QueryIndexEditor_10);
+
+		viewer.setInput(lines);
+		viewer.refresh();
+		// System.out.println("table refreshed from "+from+" to "+to+" with : "+lines);
+		topLine = from;
+		bottomLine = to;
+		for (TableColumn col : viewer.getTable().getColumns()) {
+			col.pack();
+		}
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * 
+	 * @see org.eclipse.ui.part.EditorPart#getTitleToolTip()
+	 */
+	@Override
+	public String getTitleToolTip() {
+		if (queryindex != null) {
+			String str = Messages.QueryIndexEditor_11;
+
+			return str;
+		}
+		return ""; //$NON-NLS-1$
+	}
+
+	/**
+	 * Sets the focus.
+	 * 
+	 * @see org.eclipse.ui.part.WorkbenchPart#setFocus()
+	 */
+	@Override
+	public void setFocus() {
+		this.queryWidget.setFocus();
+		StatusLine.setMessage(IndexUIMessages.IndexEditor_29);
+	}
+
+	/**
+	 * Gets the corpus.
+	 * 
+	 * @return the corpus
+	 */
+	public Corpus getCorpus() {
+		return this.corpus;
+	}
+
+	/**
+	 * Gets the partition.
+	 * 
+	 * @return the partition
+	 */
+	public Partition getPartition() {
+		return this.partition;
+	}
+
+	/**
+	 * Sets the focus.
+	 * 
+	 * @param query
+	 *            the new focus
+	 */
+	public void setFocus(String query) {
+		this.queryWidget.setText(query);
+	}
+
+	/**
+	 * Gets the index.
+	 * 
+	 * @return the index
+	 */
+	public Object getIndex() {
+		return this.queryindex;
+	}
+
+	@Override
+	public void updateResultFromEditor() {
+		// TODO Auto-generated method stub
+		
+	}
+
+	@Override
+	public void updateEditorFromResult(boolean update) {
+		// TODO Auto-generated method stub
+		
+	}
+}

